local metadata = {
"## Interface: 1.3.0.0 1.3RC4",
"## Title: AdditionalMapTypes",
"## Notes: FS2017 Script for registering Fruit and FillTypes, via modDesc.xml",
"## Author: Blacksheep - RC-Devil",
"## Version: 1.0.0.4",
"## Date: 08.12.2016",
"## Web: "
}
--
-- AdditionalMapTypes
--
-- @author: Blacksheep - RC-Devil
-- @version: 1.0.0.4
-- @date: 08 Dezember 2016
--
-- Copyright (C) 2016 Blacksheep - RC-Devil
--
-- Dedicated Server Tests by Biface.
-- My special thanks go to Biface at this point, for his great help and his time, which he has raised for it. Without his help, a server test would not have been possible
--
-- @Informations:
--[[
-- ############################################################################################################################################# --
	This Entrys is only used for Fruitpreparing for Earthfruits eg. Potato, Sugarbeet, etc.
	  minPreparingGrowthState="4" maxPreparingGrowthState="6" preparedGrowthState="9"
	  
	  1.0.0.4 - Added FillType Conversion for Harvester,
	  set fillTypeConversion="true" for Conversion oat or each fruittype to chaff,
	  conversionFactor="4" windrowConversionFactor="1" set the conversion to 4:1
	
	This is an example part for set in the modDesc.xml
	<AdditionalMapTypes hudsDirectory="fruitHuds/" groundTipDirectory="tipOnGround/"> <!-- Change Huds and GroundTip Directorys at this Line in modDesc.xml-->
	  <fruitType name="rye" needsSeeding="true" allowsSeeding="true" useSeedingWidth="false" directionSnapAngle="0" alignsToSun="false" minHarvestingGrowthState="4" maxHarvestingGrowthState="6" cutState="8" allowsPartialGrowthState="false" pricePerLiter="0.41" literPerSqm="1.2" seedUsagePerSqm="0.05" showOnPriceTable="false" shownOnMap="true" massPerLiter="0.0005" maxPhysicalSurfaceAngle="22.5" useForFieldJob="true" minForageGrowthState="5" witheringNumGrowthStates="7" numGrowthStates="6" growthStateTime="28800000" resetsSpray="false" groundTypeChangeGrowthState="0" groundTypeChanged="0" isEarthfruit="false" minPreparingGrowthState="4" maxPreparingGrowthState="6" preparedGrowthState="9" hasWindrow="false" windrowPricePerLiter="0.04" windrowLiterPerSqm="1.2" windrowShowOnPriceTable="true" windrowMassPerLiter="0.0003" windrowMaxPhysicalSurfaceAngle="50" hasStraw="false" hasFill="true" hasMaterials="false" hasParticles="false" useHeap="true" hasFillGroupUnknown="false" hasFillGroupBulk="true" hasFillGroupLiquid="false" hasFillGroupWindrow="false" hasFillGroupPiece="false" hasFillGroupCombine="true" hasFillGroupForageHarvester="false" hasFillGroupForageWagon="false" hasFillGroupSlurryTank="false" hasFillGroupManureSpreader="false" hasFillGroupSpreader="false" hasFillGroupSprayer="false" hasFillGroupFork="false" hasFillGroupTrainWagon="false" hasFillGroupAugerWagon="true" useGrainHeader="true" useMaizeHeader="false" useDirectCutter="true" usePickup="false" usePlanter="true" useAsCowBasefeed="false" useAsCowGrass="false" useAsCowPower="false" useAsSheepGrass="false" useAsPigBasefeed="false" useAsPigGrain="false" useAsPigProtein="false" useAsPigEarthfruit="false" fillTypeConversion="false" conversionFactor="4" windrowConversionFactor="1" />
	  <fruitType name="oat" needsSeeding="true" allowsSeeding="true" useSeedingWidth="false" directionSnapAngle="0" alignsToSun="false" minHarvestingGrowthState="4" maxHarvestingGrowthState="6" cutState="8" allowsPartialGrowthState="false" pricePerLiter="0.41" literPerSqm="1.2" seedUsagePerSqm="0.05" showOnPriceTable="false" shownOnMap="true" massPerLiter="0.0005" maxPhysicalSurfaceAngle="22.5" useForFieldJob="true" minForageGrowthState="5" witheringNumGrowthStates="7" numGrowthStates="6" growthStateTime="28800000" resetsSpray="false" groundTypeChangeGrowthState="0" groundTypeChanged="0" isEarthfruit="false" minPreparingGrowthState="5" maxPreparingGrowthState="5" preparedGrowthState="9" hasWindrow="true" windrowPricePerLiter="0.04" windrowLiterPerSqm="1.2" windrowShowOnPriceTable="true" windrowMassPerLiter="0.0003" windrowMaxPhysicalSurfaceAngle="50" hasStraw="false" hasFill="true" hasMaterials="false" hasParticles="false" useHeap="true" hasFillGroupUnknown="false" hasFillGroupBulk="true" hasFillGroupLiquid="false" hasFillGroupWindrow="false" hasFillGroupPiece="false" hasFillGroupCombine="true" hasFillGroupForageHarvester="false" hasFillGroupForageWagon="false" hasFillGroupSlurryTank="false" hasFillGroupManureSpreader="false" hasFillGroupSpreader="false" hasFillGroupSprayer="false" hasFillGroupFork="false" hasFillGroupTrainWagon="false" hasFillGroupAugerWagon="true" useGrainHeader="true" useMaizeHeader="false" useDirectCutter="true" usePickup="false" usePlanter="false" useAsCowBasefeed="false" useAsCowGrass="false" useAsCowPower="false" useAsSheepGrass="false" useAsPigBasefeed="false" useAsPigGrain="false" useAsPigProtein="false" useAsPigEarthfruit="false" fillTypeConversion="false" conversionFactor="4" windrowConversionFactor="1" forageWagonConversion="wheat" />
	  <fruitType name="spelt" needsSeeding="true" allowsSeeding="true" useSeedingWidth="false" directionSnapAngle="0" alignsToSun="false" minHarvestingGrowthState="4" maxHarvestingGrowthState="6" cutState="8" allowsPartialGrowthState="false" pricePerLiter="0.41" literPerSqm="1.2" seedUsagePerSqm="0.05" showOnPriceTable="false" shownOnMap="true" massPerLiter="0.0005" maxPhysicalSurfaceAngle="22.5" useForFieldJob="true" minForageGrowthState="5" witheringNumGrowthStates="7" numGrowthStates="6" growthStateTime="28800000" resetsSpray="false" groundTypeChangeGrowthState="0" groundTypeChanged="0" isEarthfruit="false" minPreparingGrowthState="1" maxPreparingGrowthState="7" preparedGrowthState="9" hasWindrow="false" windrowPricePerLiter="0.04" windrowLiterPerSqm="1.2" windrowShowOnPriceTable="false" windrowMassPerLiter="0.0003" windrowMaxPhysicalSurfaceAngle="50" hasStraw="false" hasFill="true" hasMaterials="false" hasParticles="false" useHeap="true" hasFillGroupUnknown="false" hasFillGroupBulk="true" hasFillGroupLiquid="false" hasFillGroupWindrow="false" hasFillGroupPiece="false" hasFillGroupCombine="true" hasFillGroupForageHarvester="false" hasFillGroupForageWagon="false" hasFillGroupSlurryTank="false" hasFillGroupManureSpreader="false" hasFillGroupSpreader="false" hasFillGroupSprayer="false" hasFillGroupFork="false" hasFillGroupTrainWagon="false" hasFillGroupAugerWagon="true" useGrainHeader="true" useMaizeHeader="false" useDirectCutter="true" usePickup="false" usePlanter="false" useAsCowBasefeed="false" useAsCowGrass="false" useAsCowPower="false" useAsSheepGrass="false" useAsPigBasefeed="false" useAsPigGrain="false" useAsPigProtein="false" useAsPigEarthfruit="false" fillTypeConversion="false" conversionFactor="4" windrowConversionFactor="1" />
	  <fruitType name="triticale" needsSeeding="true" allowsSeeding="true" useSeedingWidth="false" directionSnapAngle="0" alignsToSun="false" minHarvestingGrowthState="4" maxHarvestingGrowthState="6" cutState="8" allowsPartialGrowthState="false" pricePerLiter="0.41" literPerSqm="1.2" seedUsagePerSqm="0.05" showOnPriceTable="false" shownOnMap="true" massPerLiter="0.0005" maxPhysicalSurfaceAngle="22.5" useForFieldJob="true" minForageGrowthState="5" witheringNumGrowthStates="7" numGrowthStates="6" growthStateTime="28800000" resetsSpray="false" groundTypeChangeGrowthState="0" groundTypeChanged="0" isEarthfruit="false" minPreparingGrowthState="1" maxPreparingGrowthState="7" preparedGrowthState="9" hasWindrow="false" windrowPricePerLiter="0.04" windrowLiterPerSqm="1.2" windrowShowOnPriceTable="false" windrowMassPerLiter="0.0003" windrowMaxPhysicalSurfaceAngle="50" hasStraw="false" hasFill="true" hasMaterials="false" hasParticles="false" useHeap="true" hasFillGroupUnknown="false" hasFillGroupBulk="true" hasFillGroupLiquid="false" hasFillGroupWindrow="false" hasFillGroupPiece="false" hasFillGroupCombine="true" hasFillGroupForageHarvester="false" hasFillGroupForageWagon="false" hasFillGroupSlurryTank="false" hasFillGroupManureSpreader="false" hasFillGroupSpreader="false" hasFillGroupSprayer="false" hasFillGroupFork="false" hasFillGroupTrainWagon="false" hasFillGroupAugerWagon="true" useGrainHeader="true" useMaizeHeader="false" useDirectCutter="true" usePickup="false" usePlanter="false" useAsCowBasefeed="false" useAsCowGrass="false" useAsCowPower="false" useAsSheepGrass="false" useAsPigBasefeed="false" useAsPigGrain="false" useAsPigProtein="false" useAsPigEarthfruit="false" fillTypeConversion="false" conversionFactor="4" windrowConversionFactor="1" />
	  <fruitType name="millet" needsSeeding="true" allowsSeeding="true" useSeedingWidth="false" directionSnapAngle="0" alignsToSun="false" minHarvestingGrowthState="4" maxHarvestingGrowthState="6" cutState="8" allowsPartialGrowthState="false" pricePerLiter="0.41" literPerSqm="1.2" seedUsagePerSqm="0.05" showOnPriceTable="false" shownOnMap="true" massPerLiter="0.0005" maxPhysicalSurfaceAngle="22.5" useForFieldJob="true" minForageGrowthState="5" witheringNumGrowthStates="7" numGrowthStates="6" growthStateTime="28800000" resetsSpray="false" groundTypeChangeGrowthState="0" groundTypeChanged="0" isEarthfruit="false" minPreparingGrowthState="1" maxPreparingGrowthState="7" preparedGrowthState="9" hasWindrow="false" windrowPricePerLiter="0.04" windrowLiterPerSqm="1.2" windrowShowOnPriceTable="false" windrowMassPerLiter="0.0003" windrowMaxPhysicalSurfaceAngle="50" hasStraw="false" hasFill="true" hasMaterials="false" hasParticles="false" useHeap="true" hasFillGroupUnknown="false" hasFillGroupBulk="true" hasFillGroupLiquid="false" hasFillGroupWindrow="false" hasFillGroupPiece="false" hasFillGroupCombine="true" hasFillGroupForageHarvester="false" hasFillGroupForageWagon="false" hasFillGroupSlurryTank="false" hasFillGroupManureSpreader="false" hasFillGroupSpreader="false" hasFillGroupSprayer="false" hasFillGroupFork="false" hasFillGroupTrainWagon="false" hasFillGroupAugerWagon="true" useGrainHeader="true" useMaizeHeader="false" useDirectCutter="true" usePickup="false" usePlanter="false" useAsCowBasefeed="false" useAsCowGrass="false" useAsCowPower="false" useAsSheepGrass="false" useAsPigBasefeed="false" useAsPigGrain="false" useAsPigProtein="false" useAsPigEarthfruit="false" fillTypeConversion="false" conversionFactor="4" windrowConversionFactor="1" />
	  
	  <fillType name="seeds2" pricePerLiter="0.8" showOnPriceTable="true" massPerLiter="0.0005" hasGroupUnknown="false" hasGroupBulk="true" hasGroupLiquid="false" hasGroupWindrow="false" hasGroupPiece="false" hasGroupCombine="false" hasGroupForageHarvester="false" hasGroupForageWagon="false" hasGroupSlurryTank="false" hasGroupManureSpreader="false" hasGroupSpreader="false" hasGroupSprayer="false" hasGroupFork="false" hasGroupTrainWagon="false" hasGroupAugerWagon="true" hasMaterials="true" hasParticles="true" useHeap="true" isCowBasefeed="false" isCowGrass="false" isCowPower="false" isCowWindrow="false" isCowLiquid="false" isSheepGrass="false" isSheepLiquid="false" isPigBasefeed="false" isPigGrain="false" isPigProtein="false" isPigEarthfruit="false" isPigWindrow="false" isPigLiquid="false" />
	  <fillType name="lime" pricePerLiter="0.8" showOnPriceTable="true" massPerLiter="0.0006" hasGroupUnknown="false" hasGroupBulk="true" hasGroupLiquid="false" hasGroupWindrow="false" hasGroupPiece="false" hasGroupCombine="false" hasGroupForageHarvester="false" hasGroupForageWagon="false" hasGroupSlurryTank="false" hasGroupManureSpreader="false" hasGroupSpreader="false" hasGroupSprayer="false" hasGroupFork="false" hasGroupTrainWagon="false" hasGroupAugerWagon="true" hasMaterials="true" hasParticles="true" useHeap="true" isCowBasefeed="false" isCowGrass="false" isCowPower="false" isCowWindrow="false" isCowLiquid="false" isSheepGrass="false" isSheepLiquid="false" isPigBasefeed="false" isPigGrain="false" isPigProtein="false" isPigEarthfruit="false" isPigWindrow="false" isPigLiquid="false" />
	  <fillType name="compost" pricePerLiter="0.8" showOnPriceTable="true" massPerLiter="0.0008" hasGroupUnknown="false" hasGroupBulk="true" hasGroupLiquid="false" hasGroupWindrow="false" hasGroupPiece="false" hasGroupCombine="false" hasGroupForageHarvester="false" hasGroupForageWagon="false" hasGroupSlurryTank="false" hasGroupManureSpreader="false" hasGroupSpreader="false" hasGroupSprayer="false" hasGroupFork="true" hasGroupTrainWagon="false" hasGroupAugerWagon="true" hasMaterials="true" hasParticles="true" useHeap="true" isCowBasefeed="false" isCowGrass="false" isCowPower="false" isCowWindrow="false" isCowLiquid="false" isSheepGrass="false" isSheepLiquid="false" isPigBasefeed="false" isPigGrain="false" isPigProtein="false" isPigEarthfruit="false" isPigWindrow="false" isPigLiquid="false" />
	  <fillType name="sand" pricePerLiter="0.8" showOnPriceTable="true" massPerLiter="0.0008" hasGroupUnknown="false" hasGroupBulk="true" hasGroupLiquid="false" hasGroupWindrow="false" hasGroupPiece="false" hasGroupCombine="false" hasGroupForageHarvester="false" hasGroupForageWagon="false" hasGroupSlurryTank="false" hasGroupManureSpreader="false" hasGroupSpreader="false" hasGroupSprayer="false" hasGroupFork="false" hasGroupTrainWagon="false" hasGroupAugerWagon="true" hasMaterials="true" hasParticles="true" useHeap="true" isCowBasefeed="false" isCowGrass="false" isCowPower="false" isCowWindrow="false" isCowLiquid="false" isSheepGrass="false" isSheepLiquid="false" isPigBasefeed="false" isPigGrain="false" isPigProtein="false" isPigEarthfruit="false" isPigWindrow="false" isPigLiquid="false" />
	</AdditionalMapTypes>
	
	Informations about the Texture Filenames
	Hud Texture Format: DTX5 256x256px and small DTX5 64x64px
	Hud Textures Filename-Format: 
    for FruitTypehuds: hud_fruit_rye.dds and hud_fruit_rye_small.dds 
	for FillTypehuds: hud_fill_sand.dds and hud_fill_sand_small.dds
	for Windrow Types: hud_oat_windrow.dds and hud_oat_windrow_small.dds
	
	GroundTip Texture Formats: 
	diffuse DTX5 use MipMap 512x512px
	normal DTX1 use MipMap 512x512px
	distance DTX1 use MipMap 256x256ps
	
	GroundTip Textures Filename-Format:
	for diffuse Textures: lime_diffuse.dds
	for normal Textures: lime_normal.dds
	for distance Textures: limeDistance_diffuse.dds
	
	Includes Samples for Fillplanes Materialholders and ParticleSystem

-- ############################################################################################################################################# --
--]]

--[[
For Debugging: 
set DebugEbene ? 1; for Debug Lines from FruitTypes, 
set DebugEbene ? 2; for Debug Lines from FillTypes, 
set DebugEbene ? 10; for Debug Lines from All.
--]]

local DebugEbene = 10;
local function getmdata(v) v="## "..v..": "; for i=1,table.getn(metadata) do local _,n=string.find(metadata[i],v);if n then return (string.sub (metadata[i], n+1)); end;end;end;
local function Debug(e,s,...) if e <= DebugEbene then print((getmdata("Title")).." v"..(getmdata("Version"))..": "..string.format(s,...)); end; end;
local function L(name) local t = getmdata("Title"); return g_i18n:hasText(t.."_"..name) and g_i18n:getText(t.."_"..name) or name; end


AdditionalMapTypes = {};

AdditionalMapTypes.version = '1.0.0.4';
AdditionalMapTypes.author = 'Blacksheep - RC-Devil';
AdditionalMapTypes.date = '08 Dezember 2016';
local amtDir = g_currentModDirectory;

function AdditionalMapTypes:start(amtDir)

	 if self.initialized then 
	    return 
	 end;

	local amtDir = g_currentModDirectory;
	local xmlFilePath =  Utils.getFilename('modDesc.xml', amtDir);
	if fileExists(xmlFilePath) then
		local xmlFile = loadXMLFile('modDescXML', xmlFilePath);
		local key = 'modDesc.AdditionalMapTypes';
		if hasXMLProperty(xmlFile, key) then
			local hudsDirectory = getXMLString(xmlFile, key..'#hudsDirectory');
			local groundTipDirectory = getXMLString(xmlFile, key..'#groundTipDirectory');
			local hasHolders = Utils.getNoNil(getXMLBool(xmlFile, key..'#hasHolders'), false);
			if hudsDirectory ~= nil and groundTipDirectory ~= nil then
            if hudsDirectory:sub(-1) ~= '/' then
               hudsDirectory = hudsDirectory .. '/';
            end;
               hudsDirectory = amtDir .. hudsDirectory;
            if groundTipDirectory:sub(-1) ~= '/' then
            groundTipDirectory = groundTipDirectory .. '/';
         end;
            groundTipDirectory = amtDir .. groundTipDirectory;
		    self:registerFruitTypes(xmlFile, key, hudsDirectory, groundTipDirectory);
      else
         if hudsDirectory == nil then print('\\__ Error: AdditionalMapTypes could not find Huds Directory.');end;
         if groundTipDirectory == nil then print('\\__ Error: AdditionalMapTypes could not find GroundTip Directory.');end;
      end;
			Debug(-1,('\\__ AdditionalMapTypes V%s by %s from %s was loaded successful'):format(AdditionalMapTypes.version, AdditionalMapTypes.author, AdditionalMapTypes.date));
		end; 
		delete(xmlFile);
	end; 
	 self.initialized = true;
end;

function AdditionalMapTypes:registerFruitTypes(xmlFile, key, hudsDirectory, groundTipDirectory)
local amtDir = g_currentModDirectory;
Debug(-1,('\\__ AdditionalMapTypes V%s by %s from %s is loading'):format(AdditionalMapTypes.version, AdditionalMapTypes.author, AdditionalMapTypes.date));
    
-- FRUITTYPES --
local a = 0
	while true do
		local fruitTypeKey = key .. ('.fruitType(%d)'):format(a);
		if not hasXMLProperty(xmlFile, fruitTypeKey) then
			break;
		end;
		local name = getXMLString(xmlFile, fruitTypeKey..'#name');
		if name == nil then
			print(('\\__ Error: missing "name" attribute for fruitType #%d in "AdditionalMapTypes". Adding fruitTypes aborted.'):format(a));
			break;
		end;
		local gameKey = 'FRUITTYPE_' .. name:upper();
		if FruitUtil[gameKey] == nil then
			local fruitType = {		
				name = name,
				needsSeeding =                   Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#needsSeeding'), true),
				allowsSeeding =                  Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#allowsSeeding'), true),
				useSeedingWidth =                Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useSeedingWidth'), false),
				directionSnapAngle =             Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#directionSnapAngle'), 0),
				alignsToSun =                    Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#alignsToSun'), false),
				minHarvestingGrowthState =       Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#minHarvestingGrowthState'), 4),
				maxHarvestingGrowthState =       Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#maxHarvestingGrowthState'), 6),
				cutState =                       Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#cutState'), 8),
				allowsPartialGrowthState =       Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#allowsPartialGrowthState'), false),
				pricePerLiter =                  Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#pricePerLiter'), 0.31),
				literPerSqm =                    Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#literPerSqm'), 1.2),
				seedUsagePerSqm =                Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#seedUsagePerSqm'), 0.05),
				showOnPriceTable =               Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#showOnPriceTable'), true),
				shownOnMap =                     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#shownOnMap'), true),
				massPerLiter = 			         Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#massPerLiter'), 0.0005),
				maxPhysicalSurfaceAngle =        Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#maxPhysicalSurfaceAngle'), 22.5),
				useForFieldJob =                 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useForFieldJob'), false),
				minForageGrowthState =           Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#minForageGrowthState'), 5),
				witheringNumGrowthStates =       Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#witheringNumGrowthStates'), 7),
				numGrowthStates =                Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#numGrowthStates'), 6),
				growthStateTime =                Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#growthStateTime'), 7*3600000),
				resetsSpray =                    Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#resetsSpray'), false),
				groundTypeChangeGrowthState =    Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#groundTypeChangeGrowthState'), 0),
				groundTypeChanged =              Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#groundTypeChanged'), 0),
				isEarthfruit =                   Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#isEarthfruit'), false),
				minPreparingGrowthState =        Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#minPreparingGrowthState'), 1),
				maxPreparingGrowthState =        Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#maxPreparingGrowthState'), 7),
				preparedGrowthState =            Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#preparedGrowthState'), 6),				
				hasWindrow = 			         Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasWindrow'), false),
				windrowPricePerLiter =           Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#windrowPricePerLiter'), 0.041),
				windrowLiterPerSqm =             Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#windrowLiterPerSqm'), 2.5),
				windrowShowOnPriceTable =        Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#windrowShowOnPriceTable'), false),
				windrowMassPerLiter =            Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#windrowMassPerLiter'), 0.0005),
				windrowMaxPhysicalSurfaceAngle = Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#windrowMaxPhysicalSurfaceAngle'), 50),
				hasFill = 			             Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFill'), false),
				hasStraw = 			             Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasStraw'), false),
				hasMaterials = 			         Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasMaterials'), false),
				hasParticles = 			         Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasParticles'), false),
				useHeap = 			             Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useHeap'), false),
				hasFillGroupUnknown = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupUnknown'), false),
				hasFillGroupBulk = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupBulk'), false),
				hasFillGroupLiquid = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupLiquid'), false),
				hasFillGroupWindrow = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupWindrow'), false),
				hasFillGroupPiece = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupPiece'), false),
				hasFillGroupAnimal = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupAnimal'), false),
				hasFillGroupCombine = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupCombine'), false),
				hasFillGroupForageHarvester = 	 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupForageHarvester'), false),
				hasFillGroupForageWagon = 		 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupForageWagon'), false),
				hasFillGroupSlurryTank = 		 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupSlurryTank'), false),
				hasFillGroupManureSpreader = 	 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupManureSpreader'), false),
				hasFillGroupSpreader = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupSpreader'), false),
				hasFillGroupSprayer = 			 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupSprayer'), false),
				hasFillGroupFork = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupFork'), false),
				hasFillGroupTrainWagon = 		 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupTrainWagon'), false),
				hasFillGroupAugerWagon = 		 Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#hasFillGroupAugerWagon'), false),
				useGrainHeader = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useGrainHeader'), false),
				useMaizeHeader = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useMaizeHeader'), false),
				useDirectCutter = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useDirectCutter'), false),
				usePickup = 			         Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#usePickup'), false),
				usePlanter = 			         Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#usePlanter'), false),
				useAsCowBasefeed = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsCowBasefeed'), false),
				useAsCowGrass = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsCowGrass'), false),
				useAsCowPower = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsCowPower'), false),
				useAsSheepGrass = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsSheepGrass'), false),
				useAsPigBasefeed = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsPigBasefeed'), false),
				useAsPigGrain = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsPigGrain'), false),
				useAsPigProtein = 			     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsPigProtein'), false),
				useAsPigEarthfruit = 		     Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#useAsPigEarthfruit'), false),
				fillTypeConversion =             Utils.getNoNil(getXMLBool(xmlFile, fruitTypeKey..'#fillTypeConversion'), false),
				conversionFactor =               Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#conversionFactor'), 4),
				windrowConversionFactor =        Utils.getNoNil(getXMLFloat(xmlFile, fruitTypeKey..'#windrowConversionFactor'), 1),				
				forageWagonConversion =          getXMLString(xmlFile, fruitTypeKey..'#forageWagonConversion')
				};	  
			local localName = fruitType.name;
			if g_i18n:hasText(fruitType.name) then
				localName = g_i18n:getText(fruitType.name);
				g_i18n.globalI18N.texts[fruitType.name] = localName;
			end;
			Debug(1,('\\_ FruitType %s Debug Start'):format(fruitType.name));
			local hudFile = ('%shud_fruit_%s.dds'):format(hudsDirectory, fruitType.name);
			local hudFile_small = ('%shud_fruit_%s_small.dds'):format(hudsDirectory, fruitType.name);			
			if not fileExists(Utils.getFilename(hudFile_small, self.amtDir)) then				
				print("\\__ "..hudFile_small.." These are *not* 100%, please check your huds directory or your hud file")
				hudFile_small = hudFile;
			end;
			local key = FruitUtil.registerFruitType(fruitType.name, localName, nil, fruitType.needsSeeding, fruitType.allowsSeeding, fruitType.useSeedingWidth, fruitType.directionSnapAngle, fruitType.alignsToSun, fruitType.minHarvestingGrowthState, fruitType.maxHarvestingGrowthState, fruitType.cutState, fruitType.allowsPartialGrowthState, fruitType.pricePerLiter, fruitType.literPerSqm, fruitType.seedUsagePerSqm, fruitType.showOnPriceTable, hudFile, hudFile_small, fruitType.shownOnMap, fruitType.massPerLiter, math.rad(fruitType.maxPhysicalSurfaceAngle), fruitType.useForFieldJob, fruitType.minForageGrowthState);
			if key ~= nil then
			Debug(1,('\\__ Register FruitType: %s (%s) [key %s]'):format(localName, fruitType.name, tostring(key)));
			local frInKey = 'FRUITTYPE_' .. name:upper();
			FruitUtil.fruitIndexToDesc[FruitUtil[frInKey]].pricePerLiter = fruitType.pricePerLiter;
			Debug(1,('\\__ Register FruitType Price: %s (%s) [Price %s]'):format(localName, fruitType.name, fruitType.pricePerLiter));
			end;			
			local key = FruitUtil.registerFruitTypeGrowth(fruitType.name, fruitType.witheringNumGrowthStates, fruitType.numGrowthStates, fruitType.growthStateTime, fruitType.resetsSpray, fruitType.groundTypeChangeGrowthState, fruitType.groundTypeChanged);
			if key ~= nil then
			Debug(1,('\\__ Register Growth: %s (%s) [key %s]'):format(localName, fruitType.name, tostring(key)));
			end;
			if fruitType.isEarthfruit ~= false then
			local prepKey = 'FRUITTYPE_' .. name:upper();
			FruitUtil.registerFruitTypePreparing(FruitUtil[prepKey], fruitType.name, fruitType.minPreparingGrowthState, fruitType.maxPreparingGrowthState, fruitType.preparedGrowthState);
			if key ~= nil then
			Debug(1,('\\__ Register Preparing: %s (%s) [key %s]'):format(localName, fruitType.name, tostring(key)));
			end;
			end		
			if fruitType.fillTypeConversion ~= false then
				local frPrKey = 'FRUITTYPE_' .. name:upper();
				FruitUtil.addFruitToFillTypeConversion(FruitUtil.FRUITTYPE_CONVERTER_FORAGEHARVESTER, FruitUtil[frPrKey], FillUtil.FILLTYPE_CHAFF, fruitType.conversionFactor, fruitType.windrowConversionFactor);
				Debug(1,('\\_______ Added FruitType: %s (%s) to ForageHarvester Conversion'):format(localName, fruitType.name));
			end
			if fruitType.hasWindrow ~= false then
				local windrowName = fruitType.name.."_windrow";
				local localName = windrowName;
				if g_i18n:hasText(g_i18n:hasText(windrowName)) then
					localName = g_i18n:hasText(windrowName);
				end;				
				local whudFile = ('%shud_%s.dds'):format(hudsDirectory, windrowName);
				local whudFile_small = ('%shud_%s_small.dds'):format(hudsDirectory, windrowName);
				if not fileExists(Utils.getFilename(whudFile_small, self.amtDir)) then
					print("\\__ "..whudFile_small.." These are *not* 100%, please check your huds directory or your hud file")
					whudFile_small = whudFile;
				end;
				local prepKey = 'FRUITTYPE_' .. name:upper();								
				FruitUtil.registerFruitTypeWindrow(FruitUtil[prepKey], windrowName, localName, nil, fruitType.windrowPricePerLiter, fruitType.windrowLiterPerSqm, fruitType.windrowShowOnPriceTable, whudFile, whudFile_small, fruitType.windrowMassPerLiter, math.rad(fruitType.windrowMaxPhysicalSurfaceAngle));
					if key ~= nil then
					Debug(1,('\\_____ Register windrowType: %s (%s)'):format(localName, windrowName));
					end;					
					local windKey = 'FILLTYPE_' .. name:upper();
					FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_WINDROW, FillUtil[windKey]);
					Debug(1,('\\_____ Added windrowType: %s (%s) to Windrow Category'):format(localName, windrowName));					
					if fruitType.hasStraw ~= false then
					local strawKey = 'FRUITTYPE_' .. name:upper();
					FruitUtil.setFruitTypeWindrow(FruitUtil[strawKey], FillUtil.FILLTYPE_STRAW, 7.0);
					Debug(1,('\\_____ Register windrowType: %s (%s) as Straw'):format(localName, windrowName));
					end					
				if fruitType.forageWagonConversion ~= nil then
				        local prepKey = 'FRUITTYPE_' .. name:upper();
						local target = 'FRUITTYPE_' .. string.upper(fruitType.forageWagonConversion);
					if fruitType.forageWagonConversion ~= nil then						
							FruitUtil.registerFruitTypeWindrowForageWagonConversion(FruitUtil[prepKey], FruitUtil[target]);
							Debug(1,('\\_______ Register ForageWagonConversion: %s -> %s'):format(windrowName, fruitType.forageWagonConversion));
							local fillsKey = 'FILLTYPE_' .. name:upper();
							FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORAGEWAGON, FillUtil[fillsKey]);
							Debug(1,('\\_______ Added windrowType: %s (%s) to ForageWagons Category'):format(localName, windrowName));							
					else
							print("Error: incorrect target for ForageWagonConversion: "..target);
					end
				end
			end;			  
			--Register FruitTypes to FillTypes-- 
		if fruitType.hasFill ~= false then			    
			local fhudFile = ('%shud_fruit_%s.dds'):format(hudsDirectory, fruitType.name);
			local fhudFile_small = ('%shud_fruit_%s_small.dds'):format(hudsDirectory, fruitType.name);			
			if not fileExists(Utils.getFilename(fhudFile_small, self.amtDir)) then				
				print("\\__ "..fhudFile_small.." These are *not* 100%, please check your huds directory or your hud file");
				fhudFile_small = fhudFile;
			end;				
				local fillsKey = 'FILLTYPE_' .. name:upper();
			    local ftfKey = FillUtil.registerFillType(fruitType.name, localName, nil, fruitType.pricePerLiter, fruitType.showOnPriceTable, fhudFile, fhudFile_small, fruitType.massPerLiter, math.rad(fruitType.maxPhysicalSurfaceAngle));
				Debug(1,('\\____ Register fillType: %s (%s) [key %s] for FruitType %s'):format(localName, fruitType.name, tostring(ftfKey), fruitType.name));

				--Add FillTypes to Categorys--
			if fruitType.hasFillGroupUnknown ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_UNKNOWN, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Unknown Category'):format(localName, fruitType.name));
			  end;
			if fruitType.hasFillGroupBulk ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_BULK, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Bulk Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupLiquid ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_LIQUID, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Liquid Category'):format(localName, fruitType.name));
              end;
			-- if fruitType.hasFillGroupWindrow ~= false then
			    -- FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_WINDROW, FillUtil[fillsKey]);
				-- Debug(1,('\\_______ Added FillType: %s (%s) to Windrow Category'):format(localName, fruitType.name));
              -- end;
			if fruitType.hasFillGroupPiece ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_PIECE, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Piece Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupCombine ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_COMBINE, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Combine Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupForageHarvester ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORAGEHARVESTER, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Forage Harvester Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupForageWagon ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORAGEWAGON, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to ForageWagon Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupSlurryTank ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SLURRYTANK, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Slurrytank Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupManureSpreader ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_MANURESPREADER, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Manurespreader Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupSpreader ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SPREADER, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Spreader Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupSprayer ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SPRAYER, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Sprayer Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupFork ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORK, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Fork Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupTrainWagon ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_TRAINWAGON, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Trainwagon Category'):format(localName, fruitType.name));
              end;
			if fruitType.hasFillGroupAugerWagon ~= false then
			    FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_AUGERWAGON, FillUtil[fillsKey]);
				Debug(1,('\\_______ Added FillType: %s (%s) to Augerwagon Category'):format(localName, fruitType.name));
              end;			  
			 -- Register MaterialType --
			  if fruitType.hasMaterials ~= false then
			     MaterialUtil.registerMaterialType(FillUtil[fillsKey]);
				 Debug(1,('\\_____ Register Materials for FillType: %s (%s)'):format(localName, fruitType.name));
			  end;			 
			  -- Register Particles --
			  if fruitType.hasParticles ~= false then
			     MaterialUtil.registerParticleType(FillUtil[fillsKey]);
				 Debug(1,('\\_____ Register Particles for FillType: %s (%s)'):format(localName, fruitType.name));
			  end;			  
			--Register FruitTypes at Food Groups for Animals			
			--Cow Groups  
			if fruitType.useAsCowBasefeed ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 2, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as BaseFood for Cows'):format(localName, fruitType.name));
            end;
			if fruitType.useAsCowGrass ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 1, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) to Grass for Cows'):format(localName, fruitType.name));
            end;
			if fruitType.useAsCowPower ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 3, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as PowerFood for Cows'):format(localName, fruitType.name));
            end;			
			-- Sheep Groups
			if fruitType.useAsSheepGrass ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_SHEEP, 1, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as Grass for Sheeps'):format(localName, fruitType.name));
            end;						
			-- Pig Groups
			if fruitType.useAsPigBasefeed ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 1, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as BaseFood for Pigs'):format(localName, fruitType.name));
            end;
			if fruitType.useAsPigGrain ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 2, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as GrainFood for Pigs'):format(localName, fruitType.name));
            end;
			if fruitType.useAsPigProtein ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 3, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as ProteinFood for Pigs'):format(localName, fruitType.name));
            end;
			if fruitType.useAsPigEarthfruit ~= false then
				FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 4, FillUtil[fillsKey]);
				Debug(1,('\\_____ Register FillType: %s (%s) as EarthfruitFood for Pigs'):format(localName, fruitType.name));
            end;
			-- If Register any Type vor Chickens, then is the Index AnimalUtil.ANIMAL_CHICKEN
			-- Register fruitTypes at Food Groups for Animals End			
		end;		
			 -- Register Tip to Ground DensityMap for Fruit to FillTypes --
			if fruitType.useHeap ~= false then			
			local tipgDiff = ('%s%s_diffuse.dds'):format(groundTipDirectory, fruitType.name);
			local tipgNorm = ('%s%s_normal.dds'):format(groundTipDirectory, fruitType.name);
			local tipgDist = ('%s%sDistance_diffuse.dds'):format(groundTipDirectory, fruitType.name);			
			if not fileExists(Utils.getFilename(tipgDiff, self.amtDir)) then				
				print("\\__ "..tipgDiff.." not found. Please Check the Directory and File");
			end;
			if not fileExists(Utils.getFilename(tipgNorm, self.amtDir)) then				
				print("\\__ "..tipgNorm.." not found. Please Check the Directory and File");
			end;
			if not fileExists(Utils.getFilename(tipgDist, self.amtDir)) then				
				print("\\__ "..tipgDist.." not found. Please Check the Directory and File");
			end;			
    			local fillsKey = 'FILLTYPE_' .. name:upper();			 
			    TipUtil.registerDensityMapHeightType(FillUtil[fillsKey], math.rad(30), 1.0, 0.08, 0.00, 0.08, 1, true, tipgDiff, tipgNorm, tipgDist);
				Debug(1,('\\_____ Register TipOnGround DensityMapHeightType: %s (%s)'):format(localName, fruitType.name));
			end;			 
			 -- Register for Fruit Category--
			local ftfc = "FRUITTYPE_" .. string.upper(fruitType.name);
			if fruitType.allowsSeeding ~= false then
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_SOWINGMACHINE, FruitUtil[ftfc]);
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Sowingmaschines Category'):format(localName, fruitType.name));
			end;
			if fruitType.useGrainHeader ~= false then	 
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_GRAINHEADER, FruitUtil[ftfc]);
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Grainheader Category'):format(localName, fruitType.name));
			end;
			if fruitType.useMaizeHeader ~= false then	
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_MAIZEHEADER, FruitUtil[ftfc]);
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_MAIZECUTTER, FruitUtil[ftfc]);
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Maizeheader Category'):format(localName, fruitType.name));
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Maizecutters Category'):format(localName, fruitType.name));
			end;
			if fruitType.useDirectCutter ~= false then	
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_DIRECTCUTTER, FruitUtil[ftfc])
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Directcutter Category'):format(localName, fruitType.name));
			end;
			if fruitType.usePickup ~= false then	
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_PICKUP, FruitUtil[ftfc]);
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_WEEDER, FruitUtil[ftfc]);
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Pickup Category'):format(localName, fruitType.name));
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Weeder Category'):format(localName, fruitType.name));
			end;
			if fruitType.usePlanter ~= false then	
			   local key = FruitUtil.addFruitTypeToCategory(FruitUtil.FRUITTYPE_CATEGORY_PLANTER, FruitUtil[ftfc]);
			   Debug(1,('\\_____ Added FruitType: %s (%s) to Planter Category'):format(localName, fruitType.name));
			end;			
			Debug(1,('\\_ FruitType %s Debug Ende'):format(fruitType.name));
			Debug(1,'\\__________________________________________________________________________________');
			a = a + 1
		else
			a = a + 1
			print(('fruit type %q already exists. "AdditionalMapTypes" will skip its registration.'):format(name));
		end;
	end;
	
	
-- FILLTYPES --
	  local b = 0
	  while true do
		  local fillTypeKey = key .. ('.fillType(%d)'):format(b);
		  if not hasXMLProperty(xmlFile, fillTypeKey) then
			  break;
		  end;		 
		 local name = getXMLString(xmlFile, fillTypeKey..'#name');
		  if name == nil then
			  print(('\\__ Error: missing "name" attribute for fillType #%d in "AdditionalMapTypes". Adding fillTypes aborted.'):format(b));
			  break;
		  end;
		  local gameKey = 'FILLTYPE_' .. name:upper();
		  if FillUtil[gameKey] == nil then
			 local fillType = {
				  name = name,
				  pricePerLiter =            Utils.getNoNil(getXMLFloat(xmlFile, fillTypeKey..'#pricePerLiter'), 0.8),
				  showOnPriceTable =         Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#showOnPriceTable'), false),
				  massPerLiter = 			 Utils.getNoNil(getXMLFloat(xmlFile, fillTypeKey..'#massPerLiter'), 0.0005),
				  maxPhysicalSurfaceAngle =  Utils.getNoNil(getXMLFloat(xmlFile, fillTypeKey..'#maxPhysicalSurfaceAngle'), math.rad(22.5)),
				  hasGroupUnknown =          Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupUnknown'), false),
				  hasGroupBulk =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupBulk'), false),
				  hasGroupLiquid =           Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupLiquid'), false),
				  hasGroupWindrow =          Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupWindrow'), false),
				  hasGroupPiece =            Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupPiece'), false),
				  hasGroupCombine =          Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupCombine'), false),
				  hasGroupForageHarvester =  Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupForageHarvester'), false),
				  hasGroupForageWagon =      Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupForageWagon'), false),
				  hasGroupSlurryTank =       Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupSlurryTank'), false),
				  hasGroupManureSpreader =   Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupManureSpreader'), false),
				  hasGroupSpreader =         Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupSpreader'), false),
				  hasGroupSprayer =          Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupSprayer'), false),
				  hasGroupFork =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupFork'), false),
				  hasGroupTrainWagon =       Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupTrainWagon'), false),
				  hasGroupAugerWagon =       Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasGroupAugerWagon'), false),
				  hasMaterials =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasMaterials'), false),
				  hasParticles =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#hasParticles'), false),
				  useHeap =            	     Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#useHeap'), false),
				  isCowBasefeed =            Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isCowBasefeed'), false),
				  isCowGrass =            	 Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isCowGrass'), false),
				  isCowPower =            	 Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isCowPower'), false),
				  isCowWindrow =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isCowWindrow'), false),
				  isCowLiquid =            	 Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isCowLiquid'), false),
				  isSheepGrass =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isSheepGrass'), false),
				  isSheepLiquid =            Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isSheepLiquid'), false),
				  isPigBasefeed =            Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigBasefeed'), false),
				  isPigGrain =            	 Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigGrain'), false),
				  isPigProtein =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigProtein'), false),
				  isPigEarthfruit =          Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigEarthfruit'), false),
				  isPigWindrow =             Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigWindrow'), false),
				  isPigLiquid =            	 Utils.getNoNil(getXMLBool(xmlFile, fillTypeKey..'#isPigLiquid'), false)
				  };
			  local localName = fillType.name;
			  if g_i18n:hasText(fillType.name) then
				  localName = g_i18n:getText(fillType.name);
				  g_i18n.globalI18N.texts[fillType.name] = localName;
			  end;
			  Debug(2,('\\_ FillType %s Debug Start'):format(fillType.name));
			  local fhudFile = ('%shud_fill_%s.dds'):format(hudsDirectory, fillType.name);
			  local fhudFile_small = ('%shud_fill_%s_small.dds'):format(hudsDirectory, fillType.name);
			  if not fileExists(Utils.getFilename(fhudFile_small, self.amtDir)) then
			  	  print("\\__ "..fhudFile_small.." These are *not* 100%, please check your huds directory or your hud file");
			  fhudFile_small = fhudFile;
			  end;			 
			  local key = FillUtil.registerFillType(fillType.name, localName, 0, fillType.pricePerLiter, fillType.showOnPriceTable, ('%shud_fill_%s.dds'):format(hudsDirectory, fillType.name), ('%shud_fill_%s_small.dds'):format(hudsDirectory, fillType.name), fillType.massPerLiter, fillType.maxPhysicalSurfaceAngle);
			  if key ~= nil then
			  Debug(2,('\\__ Register fillType: %s (%s) [key %s]'):format(localName, fillType.name, tostring(key)));
			  end;			  
			  -- Add FillTypes to FillType Category --			
			  if fillType.hasGroupUnknown and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_UNKNOWN, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Unknown Category'):format(localName, fillType.name));
			  end;			 
			  if fillType.hasGroupBulk and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_BULK, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Bulk Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupLiquid and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_LIQUID, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Liquid Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupWindrow and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_WINDROW, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Windrow Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupPiece and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_PIECE, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Piece Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupCombine and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_COMBINE, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Combine Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupForageHarvester and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORAGEHARVESTER, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Forageharvester Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupForageWagon and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORAGEWAGON, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Foragewagon Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupSlurryTank and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SLURRYTANK, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Slurrytank Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupManureSpreader and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_MANURESPREADER, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Manurespreader Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupSpreader and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SPREADER, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Spreader Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupSprayer and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_SPRAYER, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Sprayer Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupFork and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_FORK, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Fork Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupTrainWagon and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_TRAINWAGON, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Trainwagon Category'):format(localName, fillType.name));
              end;			 
			  if fillType.hasGroupAugerWagon and key ~= nil then
			     local key = FillUtil.addFillTypeToCategory(FillUtil.FILLTYPE_CATEGORY_AUGERWAGON, key);
				 Debug(2,('\\_______ Added FillType: %s (%s) to Augerwagon Category'):format(localName, fillType.name));
              end;			
			  -- Register MaterialType --
			  local ftmt = "FILLTYPE_"..string.upper(fillType.name);
			  if fillType.hasMaterials and key ~= nil then
			  local key = MaterialUtil.registerMaterialType(FillUtil[ftmt]);
			  Debug(2,('\\_____ Register Materials for FillType: %s (%s)'):format(localName, fillType.name));
			  end;			 
			  -- Register Particles --
			  if fillType.hasParticles and key ~= nil then
			  local key = MaterialUtil.registerParticleType(FillUtil[ftmt]);
			 Debug(2,('\\_____ Register Particles for FillType: %s (%s)'):format(localName, fillType.name));
			  end;			 
			  -- Tip to Ground DensityMap for FillTypes--
			if fillType.useHeap and key ~= nil then			 
			  local tipgDiff = ('%s%s_diffuse.dds'):format(groundTipDirectory, fillType.name);
			  local tipgNorm = ('%s%s_normal.dds'):format(groundTipDirectory, fillType.name);
			  local tipgDist = ('%s%sDistance_diffuse.dds'):format(groundTipDirectory, fillType.name);
			  if not fileExists(Utils.getFilename(tipgDiff, self.amtDir)) then
			  	  print("\\__ "..tipgDiff.." not found. Please Check the Directory and File");
			  end;
			  if not fileExists(Utils.getFilename(tipgNorm, self.amtDir)) then
			      Debug(-1,"\\__ "..tipgNorm.." not found. Please Check the Directory and File");
			  end;
			  if not fileExists(Utils.getFilename(tipgDist, self.amtDir)) then
			      print("\\__ "..tipgDist.." not found. Please Check the Directory and File");
			  end;			
    			local fillsKey = 'FILLTYPE_' .. name:upper();			 
			    TipUtil.registerDensityMapHeightType(FillUtil[fillsKey], math.rad(30), 1.0, 0.08, 0.00, 0.08, 1, true, tipgDiff, tipgNorm, tipgDist);
				Debug(2,('\\_____ Register TipOnGround DensityMapHeightType: %s (%s)'):format(localName, fillType.name));
			end;			 
			 --Register FillTypes at Food Groups for Animals			
			 --Cow Groups Index 1
			if fillType.isCowBasefeed ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 2, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) to Basefood for Cows'):format(localName, fillType.name));
            end;
			if fillType.isCowGrass ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 1, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) as Grass for Cows'):format(localName, fillType.name));
            end;
			if fillType.isCowPower ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_COW, 3, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) to Powerfood for Cows'):format(localName, fillType.name));
            end;						
			 -- Sheep Groups Index 2
			if fillType.isSheepGrass ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_SHEEP, 1, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) as Grass for Sheeps'):format(localName, fillType.name));
            end;						
			 -- Pig Groups Index 3
			if fillType.isPigBasefeed ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 1, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) to Basefood for Pigs'):format(localName, fillType.name));
            end;
			if fillType.isPigGrain ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 2, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) to Grainfood for Pigs'):format(localName, fillType.name));
            end;
			if fillType.isPigProtein ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 3, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) to Proteinfood for Pigs'):format(localName, fillType.name));
            end;
			if fillType.isPigEarthfruit ~= false and key ~= nil then
				 local key = FillUtil.registerFillTypeInFoodGroup(AnimalUtil.ANIMAL_PIG, 4, key);
				 Debug(2,('\\_____ Register FillType: %s (%s) as Earthfruit for Pigs'):format(localName, fillType.name));
            end;			
			 -- If Register any Type for Chickens, then is the Index AnimalUtil.ANIMAL_CHICKEN
			 -- Register FillTypes at Food Groups for Animals End
			Debug(2,('\\_ FillType %s Debug Ende'):format(fillType.name));
			Debug(2,'\\___________________________________________________________________________________________'); 
			  b = b + 1
		  else
			  b = b + 1
			  print(('\\__ Error: fill type %q already exists. "AdditionalMapTypes" will skip its registration.'):format(name));
		  end;
	 end;
end;

AdditionalMapTypes:start(amtDir);